%define modulename memcached
%define username   memcached
%define groupname  memcached

Name:           memcached
Version:        1.4.16
Release:        1%{?dist}
Summary:        High Performance, Distributed Memory Object Cache

Group:          System Environment/Daemons
License:        BSD
URL:            http://memcached.org
Source0:        http://memcached.googlecode.com/files/%{name}-%{version}.tar.gz
Source1:        memcached.sysv
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:  libevent-devel, libxslt
BuildRequires:  perl(Test::More)

Requires: initscripts
Requires: libevent
Requires(pre):  shadow-utils
Requires(post): /sbin/chkconfig
Requires(preun): /sbin/chkconfig, /sbin/service
Requires(postun): /sbin/service

%description
memcached is a high-performance, distributed memory object caching
system, generic in nature, but intended for use in speeding up dynamic
web applications by alleviating database load.

%package devel
Summary: Development package that includes the memcached header files
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}

%description devel
The devel package contains the unbound library and the include files

%prep
%setup -q


%build
%configure --enable-replication
make CFLAGS="$RPM_OPT_FLAGS -D_GNU_SOURCE -O2 -lpthread -g " QUIET=no %{?_smp_mflags}


%install
rm -rf %{buildroot}
make install DESTDIR=%{buildroot} INSTALL="%{__install} -p"
rm -f %{buildroot}/%{_bindir}/memcached-debug
install -Dp -m0755 scripts/memcached-tool %{buildroot}%{_bindir}/memcached-tool
install -Dp -m0755 %{SOURCE1} %{buildroot}%{_initrddir}/memcached

# Default configs
mkdir -p %{buildroot}/%{_sysconfdir}/sysconfig
cat <<EOF >%{buildroot}/%{_sysconfdir}/sysconfig/%{name}
PORT="11211"
USER="%{username}"
MAXCONN="1024"
CACHESIZE="64"
OPTIONS=""
EOF

mkdir -p %{buildroot}/%{_localstatedir}/run/memcached


%clean
rm -rf %{buildroot}


%pre
getent group %{groupname} >/dev/null || groupadd -r %{groupname}
getent passwd %{username} >/dev/null || \
useradd -r -g %{groupname} -d %{_localstatedir}/run/memcached \
    -s /sbin/nologin -c "Memcached daemon" %{username}
exit 0


%post
/sbin/chkconfig --add %{name}


%preun
if [ "$1" = 0 ] ; then
    /sbin/service %{name} stop > /dev/null 2>&1
    /sbin/chkconfig --del %{name}
fi
exit 0


%postun
if [ "$1" -ge 1 ]; then
    /sbin/service %{name} condrestart > /dev/null 2>&1
fi
exit 0


%files
%defattr(-,root,root,-)
%doc AUTHORS ChangeLog COPYING NEWS doc/CONTRIBUTORS doc/*.txt
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%dir %attr(755,%{username},%{groupname}) %{_localstatedir}/run/memcached
%{_bindir}/memcached-tool
%{_bindir}/memcached
%{_mandir}/man1/memcached.1*
%{_initrddir}/memcached

%files devel
%defattr(-,root,root,-)
%{_includedir}/memcached/protocol_binary.h

%changelog
* Mon Dec 16 2013 Denis Frolov <d.frolov81@mail.ru> 1.4.16-1
- Update to 1.4.16

* Tue Sep 20 2012 Denis Frolov <d.frolov81@mail.ru> 1.4.15-1
- Update to 1.4.15

* Tue Feb 23 2012 Denis Frolov <d.frolov81@mail.ru> 1.4.13-1
- Update to 1.4.13

* Wed Nov 16 2011 Denis Frolov <d.frolov81@mail.ru> 1.4.10-1
- Update to 1.4.10

* Wed May 19 2010 Denis Frolov <d.frolov81@mail.ru> 1.4.5-1
- Update to 1.4.5

* Sat Nov 28 2009 Denis Frolov <d.frolov81@mail.ru> 1.4.4-1
- Update to 1.4.4

* Sat Nov 21 2009 Denis Frolov <d.frolov81@mail.ru> 1.4.3-1
- Update to 1.4.3

* Thu Oct 15 2009 Denis Frolov <d.frolov81@mail.ru> 1.4.2-1
- Update to 1.4.2

* Mon Aug 31 2009 Denis Frolov <d.frolov81@mail.ru> 1.4.1-1
- Update to 1.4.1

* Sun Jul 12 2009 Denis Frolov <d.frolov81@mail.ru> 1.4.0
- Initial build
